//+------------------------------------------------------------------+
//|                                           StochasticDiNapoli.mq4 |
//|                                                             Rosh |
//|               http://www.investo.ru/forum/viewtopic.php?t=127513 |
//+------------------------------------------------------------------+
#property copyright "Rosh"
#property link      "http://www.investo.ru/forum/viewtopic.php?t=127513"
//----
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red

#define SIGNAL_BAR  1
extern string EA_forex_FREE = "http://soft4forex.com";
//---- input parameters
extern int TimeFrame = 60;//       :1 - 1 ,5 - 5 , 15 - 15 , 30 - 30 , 60 - 1 , 240 - 4 , 1440 - 1 , 10080 - 1 , 43200 - 1 , 0() -    
extern int RSI=5;//    .
extern int applied_RSI=0;// .      : 0 -  , 1 -  , 2 -  , 3 -  , 4 -  , (high+low)/2, 5 -  , (high+low+close)/3, 6 -   , (high+low+close+close)/4 
extern int MA=50;//     .
extern int method_MA=0;// .         (Moving Average):0 -   , 1 -   , 2 -   ,3 - -   
extern int koridor = 5;// 
extern bool Alerts =true;
extern bool UseSound=true;
extern string SoundFile="Alert.wav";
bool SoundBuy  = False;
bool SoundSell = False;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  //---- indicator buffers mapping  
    SetIndexBuffer(0,ExtMapBuffer1);
    SetIndexBuffer(1,ExtMapBuffer2);  
    
//---- drawing settings
    SetIndexStyle(0,DRAW_ARROW);
    SetIndexArrow(0,233); //241 option for different arrow head
    SetIndexStyle(1,DRAW_ARROW);
    SetIndexArrow(1,234); //242 option for different arrow head
   
    
//----
    SetIndexEmptyValue(0,0.0);
    SetIndexEmptyValue(1,0.0);
    
//---- name for DataWindow
    SetIndexLabel(0,"TARZAN Buy");
    SetIndexLabel(1,"TARZAN Sell");
    
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int nBars,nCountedBars;

    nCountedBars=IndicatorCounted(); //ncountedbars 655
//---- check for possible errors
    if(nCountedBars<0) return(-1);
//---- last counted bar will be recounted    
    if(nCountedBars<=3)
       nBars=Bars-nCountedBars-4;
    
    if(nCountedBars>2)
      {
       nCountedBars--;
       nBars=Bars-nCountedBars-1; //number of bars in current chart-655-1
      }

   for (int ii=Bars; ii>0; ii--)
   {

      ExtMapBuffer1[ii]=0;
      ExtMapBuffer2[ii]=0;

      double myIBS  = iCustom(NULL, 0, "TARZAN",EA_forex_FREE,TimeFrame,RSI,applied_RSI,MA,method_MA,koridor,0,ii);
      double myIBS2 = iCustom(NULL, 0, "TARZAN",EA_forex_FREE,TimeFrame,RSI,applied_RSI,MA,method_MA,koridor,0,ii +1);
      
      double myI    = iCustom(NULL, 0, "TARZAN",EA_forex_FREE,TimeFrame,RSI,applied_RSI,MA,method_MA,koridor,1,ii);
      double myI2   = iCustom(NULL, 0, "TARZAN",EA_forex_FREE,TimeFrame,RSI,applied_RSI,MA,method_MA,koridor,1,ii +1);
      
      double my     = iCustom(NULL, 0, "TARZAN",EA_forex_FREE,TimeFrame,RSI,applied_RSI,MA,method_MA,koridor,2,ii);
      double my2    = iCustom(NULL, 0, "TARZAN",EA_forex_FREE,TimeFrame,RSI,applied_RSI,MA,method_MA,koridor,2,ii +1);
                       
         if(myIBS2 < my2 && myIBS > my) //did it cross from below 50
         {            
            ExtMapBuffer1[ii] = Low[ii] - 5 * MarketInfo(Symbol(),MODE_POINT);
         }
           
         if(myIBS2 > myI2 && myIBS < myI) //did it cross from above 50
         {            
            ExtMapBuffer2[ii] = High[ii] + 5 * MarketInfo(Symbol(),MODE_POINT);
         }               
      }           
   //+------------------------------------------------------------------+ 
   if(Alerts){    
      if (ExtMapBuffer1[SIGNAL_BAR] != EMPTY_VALUE && ExtMapBuffer1[SIGNAL_BAR] != 0 && SoundBuy)
         {
         SoundBuy = False;
            if (UseSound) PlaySound (SoundFile);
               Alert("TARZAN (", Symbol(), ", ", Period(), ")  -  BUY!!!"); 
         } 
      if (!SoundBuy && (ExtMapBuffer1[SIGNAL_BAR] == EMPTY_VALUE || ExtMapBuffer1[SIGNAL_BAR] == 0)) SoundBuy = True;  
            
  
      if (ExtMapBuffer2[SIGNAL_BAR] != EMPTY_VALUE && ExtMapBuffer2[SIGNAL_BAR] != 0 && SoundSell)
         {
         SoundSell = False;
            if (UseSound) PlaySound (SoundFile);
             Alert("TARZAN(", Symbol(), ", ", Period(), ")  -  SELL!!!"); 
         } 
      if (!SoundSell && (ExtMapBuffer2[SIGNAL_BAR] == EMPTY_VALUE || ExtMapBuffer2[SIGNAL_BAR] == 0)) SoundSell = True;  
}}
//+------------------------------------------------------------------+